freedombone-app-smolrss 11KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396
  1. #!/bin/bash
  2. #
  3. # _____ _ _
  4. # | __|___ ___ ___ _| |___ _____| |_ ___ ___ ___
  5. # | __| _| -_| -_| . | . | | . | . | | -_|
  6. # |__| |_| |___|___|___|___|_|_|_|___|___|_|_|___|
  7. #
  8. # Freedom in the Cloud
  9. #
  10. # License
  11. # =======
  12. #
  13. # Copyright (C) 2018 Bob Mottram <bob@freedombone.net>
  14. #
  15. # This program is free software: you can redistribute it and/or modify
  16. # it under the terms of the GNU Affero General Public License as published by
  17. # the Free Software Foundation, either version 3 of the License, or
  18. # (at your option) any later version.
  19. #
  20. # This program is distributed in the hope that it will be useful,
  21. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  22. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  23. # GNU Affero General Public License for more details.
  24. #
  25. # You should have received a copy of the GNU Affero General Public License
  26. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  27. VARIANTS='full full-vim'
  28. IN_DEFAULT_INSTALL=0
  29. SHOW_ON_ABOUT=1
  30. SHOW_ICANN_ADDRESS_ON_ABOUT=0
  31. SMOLRSS_DOMAIN_NAME=
  32. SMOLRSS_CODE=
  33. SMOLRSS_ONION_PORT=8751
  34. SMOLRSS_REPO="https://github.com/bashrc/smolrss"
  35. SMOLRSS_COMMIT='afa7135651ef87073e366b8ed183917e245ccc0e'
  36. smolrss_variables=(ONION_ONLY
  37. SMOLRSS_DOMAIN_NAME
  38. SMOLRSS_CODE
  39. DDNS_PROVIDER
  40. MY_USERNAME)
  41. function logging_on_smolrss {
  42. echo -n ''
  43. }
  44. function logging_off_smolrss {
  45. echo -n ''
  46. }
  47. function remove_user_smolrss {
  48. #remove_username="$1"
  49. echo -n ''
  50. }
  51. function add_user_smolrss {
  52. #new_username="$1"
  53. #new_user_password="$2"
  54. echo '0'
  55. }
  56. function install_interactive_smolrss {
  57. echo -n ''
  58. APP_INSTALLED=1
  59. }
  60. function change_password_smolrss {
  61. #curr_username="$1"
  62. #new_user_password="$2"
  63. echo -n ''
  64. }
  65. function reconfigure_smolrss {
  66. # This is used if you need to switch identity. Dump old keys and generate new ones
  67. echo -n ''
  68. }
  69. function smolrss_add_feed {
  70. data=$(mktemp 2>/dev/null)
  71. dialog --backtitle $"Smol RSS" \
  72. --title $"Add an RSS feed" \
  73. --form "\\n" 8 60 3 \
  74. $"Title:" 1 1 "" 1 12 40 256 \
  75. $"Feed URL:" 2 1 "" 2 12 40 10000 \
  76. 2> "$data"
  77. sel=$?
  78. case $sel in
  79. 1) rm -f "$data"
  80. return;;
  81. 255) rm -f "$data"
  82. return;;
  83. esac
  84. title=$(sed -n 1p < "$data")
  85. url=$(sed -n 2p < "$data")
  86. rm -f "$data"
  87. if [ ! "$title" ]; then
  88. return
  89. fi
  90. if [ ! "$url" ]; then
  91. return
  92. fi
  93. if [[ "$url" == *','* ]]; then
  94. return
  95. fi
  96. if [[ "$url" != *'.'* ]]; then
  97. return
  98. fi
  99. cd "/var/www/$SMOLRSS_DOMAIN_NAME/htdocs" || return
  100. if grep -q "${title}," feeds.txt; then
  101. sed -i "s|${title},.*|${title},${url}|g" feeds.txt
  102. else
  103. echo "${title},${url}" >> feeds.txt
  104. fi
  105. ./create_feeds feeds.txt > feeds.xml
  106. chown www-data:www-data feeds.txt
  107. dialog --title $"Add an RSS feed" \
  108. --msgbox $"${title} has been added" 6 70
  109. }
  110. function smolrss_remove_feed {
  111. data=$(mktemp 2>/dev/null)
  112. dialog --title $"Remove an RSS feed" \
  113. --backtitle $"Smol RSS" \
  114. --inputbox $"Enter the title of the feed to remove" 8 60 2>"$data"
  115. sel=$?
  116. case $sel in
  117. 0)
  118. title=$(<"$data")
  119. if [ "$title" ]; then
  120. cd "/var/www/$SMOLRSS_DOMAIN_NAME/htdocs" || return
  121. if grep -q "${title}," feeds.txt; then
  122. sed -i "/${title},/d" feeds.xml
  123. ./create_feeds feeds.txt > feeds.xml
  124. chown www-data:www-data feeds.txt
  125. dialog --title $"Remove an RSS feed" \
  126. --msgbox $"${title} has been removed" 6 70
  127. fi
  128. fi
  129. ;;
  130. esac
  131. rm -f "$data"
  132. }
  133. function configure_interactive_smolrss {
  134. W=(1 $"Add an RSS feed"
  135. 2 $"Remove an RSS feed"
  136. 3 $'Edit all feeds')
  137. read_config_param SMOLRSS_DOMAIN_NAME
  138. while true
  139. do
  140. # shellcheck disable=SC2068
  141. selection=$(dialog --backtitle $"Freedombone Administrator Control Panel" --title $"Smol RSS" --menu $"Choose an operation, or ESC for main menu:" 12 70 3 "${W[@]}" 3>&2 2>&1 1>&3)
  142. if [ ! "$selection" ]; then
  143. break
  144. fi
  145. case $selection in
  146. 1) smolrss_add_feed
  147. ;;
  148. 2) smolrss_remove_feed
  149. ;;
  150. 3) editor "/var/www/$SMOLRSS_DOMAIN_NAME/htdocs/feeds.txt"
  151. cd "/var/www/$SMOLRSS_DOMAIN_NAME/htdocs" || break
  152. ./create_feeds feeds.txt > feeds.xml
  153. chown www-data:www-data feeds.txt
  154. ;;
  155. esac
  156. done
  157. }
  158. function upgrade_smolrss {
  159. CURR_SMOLRSS_COMMIT=$(get_completion_param "smolrss commit")
  160. if [[ "$CURR_SMOLRSS_COMMIT" == "$SMOLRSS_COMMIT" ]]; then
  161. return
  162. fi
  163. if grep -q "smolrss domain" "$COMPLETION_FILE"; then
  164. SMOLRSS_DOMAIN_NAME=$(get_completion_param "smolrss domain")
  165. fi
  166. # update to the next commit
  167. set_repo_commit "/var/www/$SMOLRSS_DOMAIN_NAME/htdocs" "smolrss commit" "$SMOLRSS_COMMIT" "$SMOLRSS_REPO"
  168. cd "/var/www/$SMOLRSS_DOMAIN_NAME/htdocs" || return
  169. ./create_feeds feeds.txt > feeds.xml
  170. chown -R www-data:www-data "/var/www/${SMOLRSS_DOMAIN_NAME}/htdocs"
  171. }
  172. function backup_local_smolrss {
  173. SMOLRSS_DOMAIN_NAME='smolrss'
  174. if grep -q "smolrss domain" "$COMPLETION_FILE"; then
  175. SMOLRSS_DOMAIN_NAME=$(get_completion_param "smolrss domain")
  176. fi
  177. source_directory=/var/www/${SMOLRSS_DOMAIN_NAME}/htdocs
  178. suspend_site "${SMOLRSS_DOMAIN_NAME}"
  179. dest_directory=smolrss
  180. backup_directory_to_usb "$source_directory" $dest_directory
  181. restart_site
  182. }
  183. function restore_local_smolrss {
  184. if ! grep -q "smolrss domain" "$COMPLETION_FILE"; then
  185. return
  186. fi
  187. SMOLRSS_DOMAIN_NAME=$(get_completion_param "smolrss domain")
  188. if [ ! "$SMOLRSS_DOMAIN_NAME" ]; then
  189. return
  190. fi
  191. suspend_site "${SMOLRSS_DOMAIN_NAME}"
  192. temp_restore_dir=/root/tempsmolrss
  193. smolrss_dir=/var/www/${SMOLRSS_DOMAIN_NAME}/htdocs
  194. restore_directory_from_usb $temp_restore_dir smolrss
  195. if [ -d $temp_restore_dir ]; then
  196. if [ -d "$temp_restore_dir$smolrss_dir" ]; then
  197. cp -rp "$temp_restore_dir$smolrss_dir"/* "$smolrss_dir"/
  198. else
  199. if [ ! -d "$smolrss_dir" ]; then
  200. mkdir "$smolrss_dir"
  201. fi
  202. cp -rp "$temp_restore_dir"/* "$smolrss_dir"/
  203. fi
  204. chown -R www-data:www-data "$smolrss_dir"
  205. rm -rf $temp_restore_dir
  206. fi
  207. restart_site
  208. }
  209. function backup_remote_smolrss {
  210. SMOLRSS_DOMAIN_NAME='smolrss'
  211. if grep -q "smolrss domain" "$COMPLETION_FILE"; then
  212. SMOLRSS_DOMAIN_NAME=$(get_completion_param "smolrss domain")
  213. fi
  214. source_directory=/var/www/${SMOLRSS_DOMAIN_NAME}/htdocs
  215. suspend_site "${SMOLRSS_DOMAIN_NAME}"
  216. dest_directory=smolrss
  217. backup_directory_to_friend "$source_directory" $dest_directory
  218. restart_site
  219. }
  220. function restore_remote_smolrss {
  221. if ! grep -q "smolrss domain" "$COMPLETION_FILE"; then
  222. return
  223. fi
  224. SMOLRSS_DOMAIN_NAME=$(get_completion_param "smolrss domain")
  225. if [ ! "$SMOLRSS_DOMAIN_NAME" ]; then
  226. return
  227. fi
  228. suspend_site "${SMOLRSS_DOMAIN_NAME}"
  229. temp_restore_dir=/root/tempsmolrss
  230. smolrss_dir=/var/www/${SMOLRSS_DOMAIN_NAME}/htdocs
  231. restore_directory_from_friend $temp_restore_dir smolrss
  232. if [ -d $temp_restore_dir ]; then
  233. if [ -d "$temp_restore_dir$smolrss_dir" ]; then
  234. cp -rp "$temp_restore_dir$smolrss_dir"/* "$smolrss_dir"/
  235. else
  236. if [ ! -d "$smolrss_dir" ]; then
  237. mkdir "$smolrss_dir"
  238. fi
  239. cp -rp $temp_restore_dir/* "$smolrss_dir"/
  240. fi
  241. chown -R www-data:www-data "$smolrss_dir"
  242. rm -rf $temp_restore_dir
  243. fi
  244. restart_site
  245. }
  246. function remove_smolrss {
  247. nginx_dissite "$SMOLRSS_DOMAIN_NAME"
  248. remove_certs "$SMOLRSS_DOMAIN_NAME"
  249. if [ -d "/var/www/$SMOLRSS_DOMAIN_NAME" ]; then
  250. rm -rf "/var/www/$SMOLRSS_DOMAIN_NAME"
  251. fi
  252. if [ -f "/etc/nginx/sites-available/$SMOLRSS_DOMAIN_NAME" ]; then
  253. rm "/etc/nginx/sites-available/$SMOLRSS_DOMAIN_NAME"
  254. fi
  255. remove_onion_service smolrss "${SMOLRSS_ONION_PORT}"
  256. if grep -q "smolrss" /etc/crontab; then
  257. sed -i "/smolrss/d" /etc/crontab
  258. fi
  259. remove_app smolrss
  260. remove_completion_param install_smolrss
  261. sed -i '/smolrss/d' "$COMPLETION_FILE"
  262. remove_ddns_domain "$SMOLRSS_DOMAIN_NAME"
  263. }
  264. function install_smolrss {
  265. apt-get -yq install php-gettext php-curl php-gd php-mysql git curl
  266. apt-get -yq install memcached php-memcached php-intl exiftool libfcgi0ldbl
  267. SMOLRSS_DOMAIN_NAME='smolrss.local'
  268. if [ -d "/var/www/$SMOLRSS_DOMAIN_NAME/htdocs" ]; then
  269. rm -rf "/var/www/$SMOLRSS_DOMAIN_NAME/htdocs"
  270. fi
  271. if [ -d /repos/smolrss ]; then
  272. mkdir "/var/www/$SMOLRSS_DOMAIN_NAME/htdocs"
  273. cp -r -p /repos/smolrss/. "/var/www/$SMOLRSS_DOMAIN_NAME/htdocs"
  274. cd "/var/www/$SMOLRSS_DOMAIN_NAME/htdocs" || exit 324687356
  275. git pull
  276. else
  277. git_clone "$SMOLRSS_REPO" "/var/www/$SMOLRSS_DOMAIN_NAME/htdocs"
  278. fi
  279. if [ ! -d "/var/www/$SMOLRSS_DOMAIN_NAME/htdocs" ]; then
  280. echo $'Unable to clone smolrss repo'
  281. exit 87525
  282. fi
  283. cd "/var/www/$SMOLRSS_DOMAIN_NAME/htdocs" || exit 36587356
  284. git checkout "$SMOLRSS_COMMIT" -b "$SMOLRSS_COMMIT"
  285. set_completion_param "smolrss commit" "$SMOLRSS_COMMIT"
  286. cp feeds.example.txt feeds.txt
  287. ./create_feeds feeds.txt > feeds.xml
  288. chmod g+w "/var/www/$SMOLRSS_DOMAIN_NAME/htdocs"
  289. chown -R www-data:www-data "/var/www/$SMOLRSS_DOMAIN_NAME/htdocs"
  290. add_ddns_domain "$SMOLRSS_DOMAIN_NAME"
  291. SMOLRSS_ONION_HOSTNAME=$(add_onion_service smolrss 80 "${SMOLRSS_ONION_PORT}")
  292. smolrss_nginx_site=/etc/nginx/sites-available/$SMOLRSS_DOMAIN_NAME
  293. echo -n '' > "$smolrss_nginx_site"
  294. { echo 'server {';
  295. echo " listen 127.0.0.1:$SMOLRSS_ONION_PORT default_server;";
  296. echo " server_name $SMOLRSS_ONION_HOSTNAME;";
  297. echo ''; } >> "$smolrss_nginx_site"
  298. nginx_compress "$SMOLRSS_DOMAIN_NAME"
  299. echo '' >> "$smolrss_nginx_site"
  300. nginx_security_options "$SMOLRSS_DOMAIN_NAME"
  301. { echo '';
  302. echo ' access_log /dev/null;';
  303. echo ' error_log /dev/null;';
  304. echo '';
  305. echo " root /var/www/$SMOLRSS_DOMAIN_NAME/htdocs;";
  306. echo '';
  307. echo ' index index.php;';
  308. echo ' location ~ \.php {';
  309. echo ' include snippets/fastcgi-php.conf;';
  310. echo ' fastcgi_pass unix:/var/run/php/php7.0-fpm.sock;';
  311. echo ' fastcgi_read_timeout 30;';
  312. echo ' fastcgi_param HTTPS off;';
  313. echo ' }';
  314. echo '';
  315. echo ' # Location';
  316. echo ' location / {'; } >> "$smolrss_nginx_site"
  317. nginx_limits "$SMOLRSS_DOMAIN_NAME" '15m'
  318. { echo " try_files \$uri \$uri/ index.php?\$args;";
  319. echo ' }';
  320. echo '}'; } >> "$smolrss_nginx_site"
  321. configure_php
  322. create_site_certificate "$SMOLRSS_DOMAIN_NAME" 'yes'
  323. nginx_ensite "$SMOLRSS_DOMAIN_NAME"
  324. systemctl restart php7.0-fpm
  325. systemctl restart nginx
  326. "${PROJECT_NAME}-pass" -u "$MY_USERNAME" -a smolrss -p "$SMOLRSS_ADMIN_PASSWORD"
  327. set_completion_param "smolrss domain" "$SMOLRSS_DOMAIN_NAME"
  328. APP_INSTALLED=1
  329. }
  330. # NOTE: deliberately there is no "exit 0"